Index: /trunk/SophyaPI/PIext/servnobjm.cc
===================================================================
--- /trunk/SophyaPI/PIext/servnobjm.cc	(revision 332)
+++ /trunk/SophyaPI/PIext/servnobjm.cc	(revision 333)
@@ -88,5 +1303,5 @@
 float  fxnt[10];
 
-int i,j,k;
+int i,k;
 for(i=0; i<10; i++) xnt[i] = 0.;
 
@@ -111,5 +1326,5 @@
   cerr << endl;
   string es = PeidaExc(merr);
-  cerr << "NamedObjMgr_ComputeExpressions()  Exception :" << merr << es;
+  cerr << "Services2NObjMgr::ComputeExpressions()  Exception :" << merr << es;
   } ENDTRY;
  
@@ -122,6 +1337,6 @@
 
 /* --Methode-- */
-PlotExprFunc Services2NObjMgr::LinkExprFunc(string& vardec, string& expx, string& expy, string& expz, 
-                                            string& expwt, string& cut)
+PlotExprFunc Services2NObjMgr::LinkExprFunc(string& vardec, string& expx, string& expy, 
+                                            string& expz, string& expt, string& cut)
 {
 FILE *fip;
@@ -136,17 +1351,18 @@
 if ((fip = fopen(fname.c_str(), "w")) == NULL)   { 
   string sn = fname; 
-  cout << "NamedObjMgr/LinkExprFunc_Erreur: Pb. Ouverture " << sn << endl; 
+  cout << "Services2NObjMgr/LinkExprFunc_Erreur: Pb. Ouverture " << sn << endl; 
   return(NULL); 
   }
 
 // constitution du fichier a compiler
+fputs("#include <stdlib.h> \n", fip);
 fputs("#include <math.h> \n", fip);
-fputs("int expf_pia_dl_func(double* _zz61qq_, double* _rx_61qq_, double* _ry_61qq_, double* _rz_61qq_, double* _wt_61qq_) \n{\n", fip);
+fputs("int expf_pia_dl_func(double* _zz6qi_, double* _rx_6q_, double* _ry_6q_, double* _rz_6q_, double* _rt_6q_) \n{\n", fip);
 fprintf(fip,"%s \n", vardec.c_str());
-fprintf(fip, "if (!(%s)) { *_rx_61qq_ = *_ry_61qq_ = *_rz_61qq_ = *_wt_61qq_ = 0.;  return(0); } \n", cut.c_str());
-fprintf(fip, "*_rx_61qq_ = %s ; \n", expx.c_str());
-fprintf(fip, "*_ry_61qq_ = %s ; \n", expy.c_str());
-fprintf(fip, "*_rz_61qq_ = %s ; \n", expz.c_str());
-fprintf(fip, "*_wt_61qq_ = %s ; \n", expwt.c_str());
+fprintf(fip, "if (!(%s)) { *_rx_6q_ = *_ry_6q_ = *_rz_6q_ = *_rt_6q_ = 0.;  return(0); } \n", cut.c_str());
+fprintf(fip, "*_rx_6q_ = %s ; \n", expx.c_str());
+fprintf(fip, "*_ry_6q_ = %s ; \n", expy.c_str());
+fprintf(fip, "*_rz_6q_ = %s ; \n", expz.c_str());
+fprintf(fip, "*_rt_6q_ = %s ; \n", expt.c_str());
 fputs("return(1); \n} \n", fip);
 fclose(fip);
@@ -163,5 +1379,5 @@
 dynlink = PDynLinkMgr::BuildFromCFile(fname);
 if (dynlink == NULL) { 
-  cerr << "NamedObjMgr/LinkFunctionFromFile_Erreur: Erreur creation/Ouverture SO " << endl; 
+  cerr << "Services2NObjMgr/LinkFunctionFromFile_Erreur: Erreur creation/Ouverture SO " << endl; 
   return(NULL); 
   }
@@ -170,5 +1386,5 @@
 if (retfunc == NULL) { 
   string sn = funcname; 
-  cerr << "NamedObjMgr/LinkExprFunc_Erreur: Erreur linking " << sn << endl; 
+  cerr << "Services2NObjMgr/LinkExprFunc_Erreur: Erreur linking " << sn << endl; 
   CloseDLL();
   return(NULL); 
@@ -183,186 +1399,4 @@
 }
 
-/* --Methode-- */
-void Services2NObjMgr::PlotFunc(string const & expfunc, float xmin, float xmax, int np, string dopt)
-{
-FILE *fip;
-string fname = TmpDir + "func1_pia_dl.c";
-string  cmd;
-int rc;
-
-if (!mImgapp)  return; 
-
-cmd = "rm -f " + fname;
-rc = system(cmd.c_str());
-// printf("PlotFunc_Do> %s  (Rc=%d)\n", cmd.c_str(), rc); 
-
-if ((fip = fopen(fname.c_str(), "w")) == NULL)   { 
-  string sn = fname; 
-  cout << "NamedObjMgr/PlotFunc_Erreur: Pb. Ouverture " << sn << endl; 
-  return; 
-  }
-
-// constitution du fichier a compiler
-fputs("#include <math.h> \n", fip);
-fputs("double func1_pia_dl_func(double x) \n{\n", fip);
-fprintf(fip,"return(%s); \n}\n", expfunc.c_str());
-fclose(fip);
-
-string func = "func1_pia_dl_func";
-DlFunctionOfX f = (DlFunctionOfX) LinkFunctionFromFile(fname, func);
-if (!f) return; 
-PlotFunc(f, xmin, xmax, np, dopt);
-CloseDLL();
-return;
-}
-
-/* --Methode-- */
-void Services2NObjMgr::PlotFunc2D(string const & expfunc, float xmin, float xmax, float ymin, float ymax, 
-                             int npx, int npy, string dopt)
-{
-FILE *fip;
-string fname = TmpDir + "func2_pia_dl.c";
-string cmd;
-int rc;
-
-if (!mImgapp)  return; 
-
-cmd = "rm " + fname;
-rc = system(cmd.c_str());
-// printf("PlotFunc2D_Do> %s  (Rc=%d)\n", cmd.c_str(), rc); 
-
-if ((fip = fopen(fname.c_str(), "w")) == NULL)   { 
-  string sn = fname; 
-  cout << "NamedObjMgr/PlotFunc2D_Erreur: Pb. Ouverture " << sn << endl; 
-  return; 
-  }
-
-// constitution du fichier a compiler
-fputs("#include <math.h> \n", fip);
-fputs("double func2_pia_dl_func(double x, double y) \n{\n", fip);
-fprintf(fip,"return(%s); \n}\n", expfunc.c_str());
-fclose(fip);
-
-string func = "func2_pia_dl_func";
-DlFunctionOfXY f = (DlFunctionOfXY) LinkFunctionFromFile(fname, func);
-if (!f)  return;
-PlotFunc2D(f, xmin, xmax, ymin, ymax, npx, npy, dopt);
-CloseDLL();
-return;
-}
-
-/* --Methode-- */
-void Services2NObjMgr::PlotFuncFrCFile(string const & fname, string const & func, float xmin, float xmax, 
-                                       int np, string dopt)
-{
-DlFunctionOfX f = (DlFunctionOfX) LinkFunctionFromFile(fname, func);
-if (!f) return; 
-PlotFunc(f, xmin, xmax, np, dopt);
-CloseDLL();
-return;
-}
-
-/* --Methode-- */
-void Services2NObjMgr::PlotFunc2DFrCFile(string const & fname, string const & func, float xmin, float xmax, 
-                                         float ymin, float ymax, int npx, int npy, string dopt)
-{
-DlFunctionOfXY f = (DlFunctionOfXY) LinkFunctionFromFile(fname, func);
-if (!f)  return;
-PlotFunc2D(f, xmin, xmax, ymin, ymax, npx, npy, dopt);
-CloseDLL();
-return;
-}
-
-/* --Methode-- */
-void Services2NObjMgr::PlotFunc(DlFunctionOfX f, float xmin, float xmax, int np, string dopt)
-{
-if (!mImgapp)  return; 
-
-int k;
-if (np < 1) np = 1;
-if (xmax <= xmin) xmax = xmin+1.;
-Vector* vpy = new Vector(np);
-
-double xx;
-double dx = (xmax-xmin)/np;
-TRY {
-  for(k=0; k<np; k++) { xx = xmin+dx*k; (*vpy)(k) = f(xx); }
-} CATCH(merr) {
-  fflush(stdout); 
-  cout << endl; 
-  cerr << endl;
-  string es = PeidaExc(merr);
-  cerr << "Services2NObjMgr::PlotFunc()  Exception :" << merr << es;
-  delete vpy;
-  vpy = NULL;
-  } ENDTRY;
-
-
-if (vpy) {
-  string nom = "Func";
-  P1DArrayAdapter* vya = new POVectorAdapter(vpy, true);
-  vya->DefineXCoordinate(xmin, (xmax-xmin)/np);
-  PIYfXDrawer* dr = new   PIYfXDrawer(vya, NULL, true) ; 
-  bool fgsr = true;
-  dopt = "thinline," + dopt;
-  int opt = DecodeDispOption(dopt, fgsr);
-  int wrsid = mImgapp->DispScDrawer(dr, nom, opt);
-  if (fgsr) mImgapp->RestoreGraphicAtt(); 
-  }
-
-return;
-}
-
-/* --Methode-- */
-void Services2NObjMgr::PlotFunc2D(DlFunctionOfXY f, float xmin, float xmax, float ymin, float ymax, 
-                             int npx, int npy, string dopt)
-{
-if (!mImgapp)  return; 
-
-if (npx < 3) npx = 3;
-if (npy < 3) npy = 3;
-if (npx > 250) npx = 250;
-if (npy > 250) npy = 250;
-if (xmax <= xmin) xmax = xmin+1.;
-if (ymax <= ymin) ymax = ymin+1.;
-
-Matrix* mtx = new Matrix(npy, npx);
-
-int i,j;
-double xx, yy;
-double dx = (xmax-xmin)/npx;
-double dy = (ymax-ymin)/npy;
-// printf(" -- DBG -- %d %d , %g %g , %g %g \n", npx, npy, xmin, xmax, ymin, ymax);
-TRY {
-  for(j=0; j<npy; j++) {
-    yy = ymin+dy*j; 
-    for(i=0; i<npx; i++) {
-      xx = xmin+dx*i;
-      (*mtx)(j, i) = f(xx, yy);
-    }
-  }
-} CATCH(merr) {
-  fflush(stdout); 
-  cout << endl; 
-  cerr << endl;
-  string es = PeidaExc(merr);
-  cerr << "Services2NObjMgr::PlotFunc2D()  Exception :" << merr << es;
-  delete mtx;  mtx = NULL;
-  } ENDTRY;
-
-if (mtx) {
-  string nom = "Func2";
-  int wrsid = 0;
-  bool fgsr = true;
-  int opt = DecodeDispOption(dopt, fgsr);
-  P2DArrayAdapter* arr = new POMatrixAdapter(mtx, true);
-  arr->DefineXYCoordinates(xmin, ymin, dx, dy);
-  PISurfaceDrawer* sdr = new PISurfaceDrawer(arr, true, true, true);
-  wrsid = mImgapp->Disp3DDrawer(sdr, nom, opt);
-  if (fgsr) mImgapp->RestoreGraphicAtt();
-  }
-
-return;
-}
 
 /* --Methode-- */
@@ -663,2 +1697,70 @@
                 
 }
+
+
+// SANS_EVOLPLANCK     Attention !
+#include "pclassids.h"
+
+/* --Methode-- */
+char* Services2NObjMgr::PClassIdToClassName(int cid)
+{
+switch (cid) {
+  case ClassId_Poly1 : 
+    return("Poly1");
+  case ClassId_Poly2 : 
+    return("Poly2");
+  case ClassId_Matrix : 
+    return("Matrix");
+  case ClassId_Vector : 
+    return("Vector");
+
+  case ClassId_DVList : 
+    return("DVList");
+
+  case ClassId_Histo1D : 
+    return("Histo1D");
+  case ClassId_Histo2D : 
+    return("Histo2D");
+  case ClassId_HProf : 
+    return("HProf");
+  case ClassId_NTuple : 
+    return("NTuple");
+  case ClassId_GeneralFitData : 
+    return("GeneralFitData");
+
+  case ClassId_Image : 
+    return("RzImage");
+  case ClassId_Image + kuint_1 : 
+    return("ImageU1");
+  case ClassId_Image + kint_1 : 
+    return("ImageI1");
+  case ClassId_Image + kuint_2 : 
+    return("ImageU2");
+  case ClassId_Image + kint_2 : 
+    return("ImageI2");
+  case ClassId_Image + kuint_4 : 
+    return("ImageU4");
+  case ClassId_Image + kint_4 : 
+    return("ImageI4");
+  case ClassId_Image + kr_4 : 
+    return("ImageR4");
+  case ClassId_Image + kr_8 : 
+    return("ImageR8");
+
+  case ClassId_ZFidu : 
+    return("ZFidu");
+
+  case ClassId_StarList : 
+    return("StarList");
+  case ClassId_Transfo : 
+    return("Transfo");
+  case ClassId_PSF : 
+    return("PSF");
+
+
+// - Ajout objet PPF
+  default:
+    return("AnyDataObj");
+  }
+}  
+
Index: /trunk/SophyaPI/PIext/servnobjm.h
===================================================================
--- /trunk/SophyaPI/PIext/servnobjm.h	(revision 332)
+++ /trunk/SophyaPI/PIext/servnobjm.h	(revision 333)
@@ -25,4 +25,5 @@
 class Histo2D;
 class HProf;
+class NamedObjMgr;
 class PIStdImgApp;
 class NObjMgrAdapter;
@@ -30,5 +31,5 @@
 class Services2NObjMgr {
 public:
-         	Services2NObjMgr(PIStdImgApp* app, string& tmpdir);
+         	Services2NObjMgr(NamedObjMgr* omg, string& tmpdir);
   virtual	~Services2NObjMgr();
 
@@ -40,28 +41,64 @@
   inline void   SetImgApp(PIStdImgApp* app) {mImgapp = app; }
 
-  void 		Nobj_ComputeExpressions(NObjMgrAdapter* obja, string& expx, string& expy, string& expz, 
-                                        string& expwt, string& expcut,
-                                        NTuple* nt=NULL, Histo* h1=NULL,
-                                        Histo2D* h2=NULL, HProf* hp=NULL);
-  PlotExprFunc  LinkExprFunc(string& vardec, string& expx, string& expy, string& expz, 
-                             string& wt, string& cut);
+// Trace de fonctions 1-D , 2-D
+  virtual void  PlotFunc(string const & expfunc, string & nom, double xmin, double xmax, 
+                         int np=100, string dopt="");
+  virtual void  PlotFunc2D(string const & expfunc, string & nom, double xmin, double xmax, 
+                           double ymin, double ymax, int npx=50, int npy=50, string dopt="");
+  virtual void  PlotFuncFrCFile(string const & fname, string const & func, string & nom, 
+                                double xmin, double xmax, int np=100, string dopt="");
+  virtual void  PlotFunc2DFrCFile(string const & fname, string const & func, string & nom, 
+                                  double xmin, double xmax, double ymin, double ymax, 
+                                  int npx=50, int npy=50, string dopt="");
+  virtual void  PlotFunc(DlFunctionOfX f, string & nom, double xmin, double xmax, 
+                         int np=100, string dopt="");
+  virtual void  PlotFunc2D(DlFunctionOfXY f, string & nom, double xmin, double xmax, 
+                           double ymin, double ymax, int npx=50, int npy=50, string dopt="");
+
+//  Trace d'expression de NTuple, et d'autres objets
+  virtual void          DisplayPoints2D(string & nom, string& expx, string& expy,
+                                        string& experrx, string& experry, 
+                                        string& expcut, string dopt="");
+  virtual void          DisplayPoints3D(string & nom, string& expx, string& expy, string& expz, 
+                                        string& expcut, string dopt="");
+  virtual void          DisplayPoints2DW(string & nom, string& expx, string& expy, 
+                                         string& expwt, string& expcut, string dopt="");
+//  Projection d'expressions dans histogramme (et trace) 
+  virtual void          ProjectH1(string & nom, string& expx, string& expwt, string& expcut, 
+                                  string& nomh1, string dopt="");
+  virtual void          ProjectH2(string & nom, string& expx, string& expy, string& expwt, 
+                                  string& expcut, string& nomh2, string dopt="");
+  virtual void          ProjectHProf(string & nom, string& expx, string& expy, string& expwt, 
+                                  string& expcut, string& nomprof, string dopt="");
+//  Projection d'expression dans vecteurs et dans n-tuple
+  virtual void          FillVect(string & nom, string& expx, string& expcut, 
+                                 string& nomvec, string dopt="");
+  virtual void          FillNT(string & nom, string& expx, string& expy, string& expz,
+                               string& expt, string& expcut, string& nomnt); 
+  virtual void          FillGFD(string & nom, string& expx, string& expy, string& expz,
+                               string& experr, string& expcut, string& nomgfd);
+  virtual void          FillNTFrCFile(string & nom, string const & fname, 
+                                      string const & funcname, string & nomnt);
+  virtual void		PrepareNTExpressionCFile(string & nomobj, string const & fname, 
+                                                 string const & funcname);
+
+//   Methodes de fit -  CMV , deux methodes H1 H2 ou 1 seule ??) ...
+  virtual void          Fit12D(string & nom, string& func,
+                              string par,string step,string min,string max,string opt);
+
+// Calcul d'expressions d'interface NTuple pour les objets
+  void 		ComputeExpressions(NObjMgrAdapter* obja, string& expx, string& expy, 
+                                   string& expz, string& expt, string& expcut,
+                                   NTuple* nt=NULL, Histo* h1=NULL,
+                                   Histo2D* h2=NULL, HProf* hp=NULL);
+  PlotExprFunc  LinkExprFunc(string& vardec, string& expx, string& expy, 
+                             string& expz, string& expt, string& cut);
   DlFunction    LinkFunctionFromFile(string const & fname, string const & funcname);
   void 		CloseDLL();  
-
-// Trace de fonctions 1-D , 2-D
-  virtual void  PlotFunc(string const & expfunc, float xmin, float xmax, int np=100, string dopt="");
-  virtual void  PlotFunc2D(string const & expfunc, float xmin, float xmax, float ymin, float ymax, 
-                           int npx=50, int npy=50, string dopt="");
-  virtual void  PlotFuncFrCFile(string const & fname, string const & func, float xmin, float xmax, 
-                                int np=100, string dopt="");
-  virtual void  PlotFunc2DFrCFile(string const & fname, string const & func, float xmin, float xmax, 
-                                  float ymin, float ymax, int npx=50, int npy=50, string dopt="");
-  virtual void  PlotFunc(DlFunctionOfX f, float xmin, float xmax, int np=100, string dopt="");
-  virtual void  PlotFunc2D(DlFunctionOfXY f, float xmin, float xmax, float ymin, float ymax, 
-                           int npx=50, int npy=50, string dopt="");
 
 // Utilitaires divers 
   string 	FileName2Name(string const & fn);
   int 		DecodeDispOption(string& dopt, bool& fgsrgr);
+  char* 	PClassIdToClassName(int cid);
 
 protected:
@@ -94,4 +131,5 @@
 
   PIStdImgApp* mImgapp;
+  NamedObjMgr* mOmg;
   
 };
